<template>
  <div
    class="order-advance"
    :class="[
      isLoading && '--loading'
    ]"
  >
    <ObLoader
      v-if="isLoading"
      class="order-advance__loader"
    />
    <button
      class="order-advance__close"
      @click="setVisibleAdvance(false)"
    >
      <i class="icon close" />
    </button>
    <div class="order-advance__header">
      <div class="status">
        <span v-html="infoByStatus.icon"/>
        <div class="status__title">
          {{ infoByStatus.title }}
        </div>
      </div>
      <div class="price">{{ order.advanceAvailable / 100 | currency({ dot: 2 }) }} ₽</div>
    </div>
    <div class="order-advance__prices">
      <div class="item -green-800">
        <div class="item__title">Аванс с НДС</div>
        <div class="item__value">{{ order.advanceAvailable / 100 | currency({ dot: 2 }) }} ₽</div>
      </div>
      <div class="item">
        <div class="item__title">Сумма заказа с НДС</div>
        <div class="item__value">{{ order.totalPrice / 100 | currency({ dot: 2 }) }} ₽</div>
      </div>
      <div class="item">
        <div class="item__title">Сбор за оформление<br>документов с НДС</div>
        <div class="item__value">{{ order.advanceServicePrice / 100 | currency({ dot: 2 }) }} ₽</div>
      </div>
    </div>
    <div class="order-advance__info">
      <transition name="toggle-height">
        <template v-if="currentStatus === 'FULLY_PAID'">
          <p
            v-if="currentStatus === 'FULLY_PAID'"
            class="-green-800"
          >
            Дата получения {{ currentAdvanceInfo.paidAt | date('DD.MM.YYYY') }}
          </p>
        </template>
      </transition>
      <transition name="toggle-height">
        <div v-if="currentStatus !== 'FULLY_PAID'">
          <div class="title">Получение аванса</div>
          <p>Доступно со следующего дня, начиная со дня погрузки.</p>
        </div>
      </transition>
      <div class="title">Получение остатка</div>
      <p>В течение 10 дней после предоставления документов. Сбор за оформление документов будет вычтен из остатка.</p>
    </div>
    <button v-if="!isConditions"
       @click="download"
       class="order-advance__terms">
      Условия авансирования
    </button>
    <div v-else
         class="order-advance__conditions-loader">
      <ob-loader
          :width="10"
          :height="10"
          :duration="2"
      />
    </div>
    <transition name="fadeIn">
      <div
        v-if="currentStatus === 'DEFAULT'"
        class="order-advance__button"
      >
        <ObButton
          label="Заказать аванс"
          @click="newAdvance"
          :disabled="disabledAdvance"
        />
      </div>
    </transition>
  </div>
</template>

<script>
import api from '@/api'
import { mapGetters, mapActions, mapMutations } from 'vuex'
import { infoByStatus } from '@/components/Order/orderItem/advance/constants'
import ObButton from 'common-components/src/obComponents/obButton'
import ObLoader from 'common-components/src/obComponents/obLoader'

export default {
  name: 'OrderAdvancePanel',
  props: {
    order: {
      type: Object,
      default: () => {}
    }
  },
  components: {
    ObButton,
    ObLoader
  },
  data () {
    return {
      isConditions: false,
      isLoading: false,
      isDisabled: false
    }
  },
  computed: {
    ...mapGetters({
      advanceInfo: 'order/advanceInfo'
    }),
    currentAdvanceInfo () {
      return this.advanceInfo[this.order.uuid] || {}
    },
    currentStatus () {
      return this.currentAdvanceInfo.status || 'DEFAULT'
    },
    isCancelled () {
      return this.currentStatus === 'CANCELLED'
    },
    infoByStatus () {
      return infoByStatus(this.currentStatus)
    },
    disabledAdvance () {
      return this.isDisabled ? this.isDisabled : ((this.order.totalPrice / 100) < 10000);
    }
  },
  methods: {
    ...mapActions({
      getAdvanceInfo: 'order/getAdvanceInfo'
    }),
    ...mapMutations({
      setVisibleAdvance: 'order/setVisibleAdvance'
    }),
    async download() {
      try {
        this.isConditions = true;
        await api.accountOrder.advanceConditions(this.order.uuid)
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки файла'
        })
      } finally {
        this.isConditions = false
      }
    },
    async newAdvance () {
      this.isLoading = true;
      this.isDisabled = true;
      let notificationId = new Date().getTime() + 'new';
      this.$notification({type: 'system_notification_in_load', message: 'В процессе', id: notificationId});
      try {
        await api.orderProcess.newAdvance({
          uuid: this.order.uuid,
          amount: this.order.advanceAvailable
        });
        await this.getAdvanceInfo({
          uuid: this.order.uuid,
          price: this.order.advanceAvailable
        });
        this.$notification({type: 'system_notification_success', message: 'Аванс заказан'})
      } catch (e) {
        console.log(e);
        this.isDisabled = false;
        this.$notification({
          type: 'system_notification_error',
          message: 'Не удалось заказать аванс'
        })
      } finally {
        this.isLoading = false;
        this.$notification({event: 'close', id: notificationId})
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-advance {
    position: absolute;
    z-index: 100;
    top: 0;
    right: 0;
    width: 338px;
    min-height: 100%;
    padding: 35px 30px;
    background-color: #fff;
    box-shadow: 0px 2px 10px rgba(0, 112, 166, 0.15);
    &.--loading {
      &::before {
        content: '';
        position: absolute;
        top: 0;
        left: 0;
        z-index: 100;
        width: 100%;
        height: 100%;
        background-color: $obForm-loading_block_background-color;
      }
    }
    &__loader {
      position: absolute;
      z-index: 200;
      top: 200px;
      left: 50%;
      transform: translateX(-50%);
    }
    &__close {
      position: absolute;
      top: 25px;
      right: 23px;
      display: flex;
      justify-content: center;
      align-items: center;
      padding: 0;
      border: none;
      background-color: transparent;
      outline: none;
      cursor: pointer;
      &:hover {
        opacity: 0.8;
      }
      i {
        font-size: 22px;
        color: $color-blue-navy-blue;
      }
    }
    &__header {
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      margin-bottom: 30px;
      text-align: center;
      .status {
        display: flex;
        align-items: center;
        justify-content: center;
        &::v-deep {
          .icon, svg {
            margin-right: 12px;
          }
        }
        &__title {
          @include font-mixin(12px, 16px, 400, $green-800, 1.6px, uppercase);
        }
      }
      .price {
        margin-top: 5px;
        @include font-mixin(24px, 36px, 700, $green-800);
      }
    }
    &__prices {
      margin-bottom: 30px;
      padding-bottom: 30px;
      border-bottom: 1px solid $color-grey-border;
      .item + .item {
        margin-top: 9px;
      }
      .item {
        display: flex;
        justify-content: space-between;
        @include font-mixin(12px, 14px, 400, $color-grey-label, 0.4px);
        &__title {
          text-align: left;
        }
        &__value {
          text-align: right;
        }
      }
    }
    &__info {
      .title {
        margin-bottom: 5px;
        @include font-mixin(12px, 12px, 400, $color-text-base, 0.4px);
      }
      p {
        margin-bottom: 20px;
        @include font-mixin(12px, 14px, 400, $color-grey-label);
      }
    }
    &__terms {
      cursor: pointer;
      display: inline-block;
      margin-bottom: 30px;
      background: none;
      border: none;
      @include font-mixin(12px, 12px, 400, $blue-600);
      &:hover {
        opacity: 0.8;
      }
    }
    &__button {
      display: flex;
      justify-content: center;
    }
    &__conditions-loader{
      display: flex;
      justify-content: center;
    }
    .fadeIn-enter,
    .fadeIn-leave-to {
      opacity: 0;
    }

    .fadeIn-enter-active,
    .fadeIn-leave-active {
      transition: opacity .3s ease-in-out;
    }

    .toggle-height-enter-active,
    .toggle-height-leave-active {
      transition: all 0.4s;
      max-height: 999px;
    }

    .toggle-height-enter,
    .toggle-height-leave-to /* .fade-leave-active до версии 2.1.8 */ {
      max-height: 0;
      opacity: 0;
    }
  }
</style>
